using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using BlogEngine.Core;

public partial class themes_Standard_slideShow : System.Web.UI.UserControl
{
    private string dataSource;
    protected void Page_Load(object sender, EventArgs e)
    {
        dataSource = System.Web.HttpContext.Current.Server.MapPath(BlogSettings.Instance.StorageLocation) + "slideShow.xml";

        if (!IsPostBack)
        {
            ShowSlideShow();
        }
    }

    private void ShowSlideShow()
    {
        SlideShow current = GetCurrentSlideShow();
        HfSlideShowID.Value = current.ID.ToString();
        LblSource.Text = getscript(current.Source);
        lblLink.Text = current.Source;
    }
    private string getscript(string source)
    {
        //Set Image size here, minimum is 150 (For Picassa)
        string maxsize = "160";
        //Set Image size here,(For Flickr)
        //_t - thumbnail, 100 on longest side
        //_s - small square 75x75
        //_m - small, 240 on longest side
        string imgsize = "_m";
        //Resizing Imge (propotionality will be lost)
        bool resize=true;
        //Number of Images to be loaded
        string numberOfImages = "50";
        //Speed of the slide show in milli seconds
        string slideSpeed = "5000";
        //Show album name on the top of the slideshow
        string showalbumHeader = "false";
        //BorderSize
        string bordersize = "2";
        //BorderColor
        string borderColor = "#000";
        string script = "<div  id=\"SlideShow\" style=\"text-align:center;\"></div>";

        if (source.IndexOf("flickr.com") > 0)
        {
            script+="<script javascript=\"javascript\">var imgNum = 0; var pwaHeader = " + showalbumHeader + ";var albumDisplay = false; var pwaLogo = true; var pwaSlideShow = true; var pwaSlideSpeed =" + slideSpeed +";  var pwaImageSize =" + maxsize +";  var pwaImageFeed =" + numberOfImages +";  var pwaBorder = true;  var pwaBorderSize =" + bordersize +"; var pwaBorderColor = '" + borderColor + "';var pwaCurrent = 0;";
            script+="function pwaPlay(){if(pwaCurrent >0){ pwPrev = pwaCurrent - 1; document.getElementById('pwa'+pwPrev).style.display = 'none';} else {pwPrev = imgNum -1;document.getElementById('pwa'+pwPrev).style.display = 'none';}document.getElementById('pwa'+pwaCurrent).style.display = 'block';pwaCurrent++; if (pwaCurrent == imgNum){ pwaCurrent = 0;} setTimeout('pwaPlay()', pwaSlideSpeed);}";
            script+="function min(a, b) {return (a < b) ? a : b;}";
            script+="function jsonFlickrFeed(obj) {var pwf= document.getElementById('SlideShow');var regexi = /http:\\/\\/[a-z0-9.-]*static[^&]+/i;var i;if(pwaHeader){ h2 = document.createElement('h2'); h2a = document.createElement('a'); h2a.href = obj.link; h2a .target='_blank'; h2t = document.createTextNode(obj.title); h2a.appendChild(h2t); h2.appendChild(h2a);  pwf.appendChild(h2);}ul = document.createElement('ul');";
            script += "ul.id = 'pwaUL'; ul.style.listStyleType = 'none';for (i=0; i < min(obj.items.length, pwaImageFeed); ++i){var item = obj.items[i];var url = item.description.match(regexi);if (url instanceof Array){url = url[0];}url = url.slice(0, url.length - 6) + \"" + imgsize + ".jpg\"; var li = document.createElement('li'); var a = document.createElement('a');a .target='_blank';a .border='0px';a .setAttribute('href', item.link);";
            script+="var img = document.createElement('img');img.setAttribute('src', url);img.setAttribute('title', item.title);img.setAttribute('alt', 'Photograph of ' + item.title);";
            if (resize)
            {
                script += "img.style.height =pwaImageSize + 'px';img.style.width = pwaImageSize + 'px';";
            }
            script+="if(pwaBorder){img.style.padding = '2px';img.style.border = pwaBorderSize + 'px ' + pwaBorderColor + ' solid';} a .appendChild(img);li.appendChild(a);li.id = 'pwa' + imgNum;li.style.display = 'none';ul.appendChild(li);imgNum++;}";
            script+="pwf.appendChild(ul);pwaPlay();}</script>";
            script+="<script type=\"text/javascript\" src=\"";
            script+=replaceflickr(source);
            script+="\" defer=\"defer\"></script>";

        }
        else
        {


            script += "<script type=\"text/javascript\"> var imgNum = 0; var pwaHeader = " + showalbumHeader + ";var albumDisplay = false; var pwaLogo = true; var pwaSlideShow = true; var pwaSlideSpeed = " + slideSpeed + "; var pwaImageSize = " + maxsize + "; var pwaImageFeed = " + numberOfImages + "; ";
            script += " var pwaBorder = true; var pwaBorderSize = " + bordersize + "; var pwaBorderColor = '" + borderColor + "'; function pwShow(root) { var feed = root.feed; var entries = feed.entry || []; var pwTitle = feed.title.$t; var album = feed.link[1].href; pwf= document.getElementById('SlideShow'); if(pwaHeader) { ";
            script += " h2 = document.createElement('h2'); h2a = document.createElement('a'); h2a.href = album; h2t = document.createTextNode(pwTitle); h2a.appendChild(h2t); h2.appendChild(h2a); pwf.appendChild(h2); } ul = document.createElement('ul'); ul.id = 'pwaUL'; ul.style.listStyleType = 'none'; ";
            script += " if(feed.entry.length > pwaImageFeed) { pwaFetch = pwaImageFeed; } else { pwaFetch = feed.entry.length; } for (var i = 0; i < pwaFetch ; ++i) { var entry = feed.entry[i]; var title = entry.title.$t; var jsonImage = entry.media$group.media$content[0].url; if(albumDisplay) ";
            script += " { var link = entry.link[1].href; } else { var link = entry.link[1].href; } li = document.createElement('li'); li.style.backgroundImage = 'none'; li.style.border = '0px'; if(pwaSlideShow) { li.style.display = 'none'; li.id = 'pwa' + imgNum; } a = document.createElement('a'); ";
            script += " a.href = link;a.target='_blank'; a.title = title; img = document.createElement('img'); img.src = jsonImage + '?imgmax=' + pwaImageSize + '&crop=0';";
            if (resize)
            {
                script += "img.style.height =pwaImageSize + 'px';img.style.width = pwaImageSize + 'px';";
            }
            script+="if(pwaBorder) { img.style.padding = '2px'; img.style.border = pwaBorderSize + 'px ' + pwaBorderColor + ' solid'; img.style.height =pwaImageSize + 'px';img.style.width = pwaImageSize + 'px';} a.appendChild(img);";
            script += " li.appendChild(a); ul.appendChild(li);imgNum++; } if(pwaLogo) { logoli = document.createElement('li'); logoli.style.paddingTop = '3px'; ul.appendChild(logoli); } pwf.appendChild(ul); if(pwaSlideShow) { pwaPlay(); }} var pwaCurrent = 0;function pwaPlay(){ if(pwaCurrent >0)";
            script += " { pwPrev = pwaCurrent - 1; document.getElementById('pwa'+pwPrev).style.display = 'none'; } else { pwPrev = imgNum -1; document.getElementById('pwa'+pwPrev).style.display = 'none'; } document.getElementById('pwa'+pwaCurrent).style.display = 'block'; pwaCurrent++; if (pwaCurrent == imgNum) {";
            script += " pwaCurrent = 0; } setTimeout('pwaPlay()', pwaSlideSpeed)}</script>";
            script += "<script type=\"text/javascript\" src=\"" + source.Replace("alt=rss", "alt=json-in-script&callback=pwShow") + "\" ></script>";
        }
        return (script);
    }
    private string replaceflickr(string link)
    {
        link=link.Replace("format=rss_200","format=json");
        link=link.Replace("format=rss2","format=json");
        link=link.Replace("format=atom_1","format=json");
        link=link.Replace("format=atom","format=json");
        link=link.Replace("format=rss_091","format=json");
        link=link.Replace("format=rss_092","format=json");
        link=link.Replace("format=rss_100","format=json");
        link=link.Replace("format=rss","format=json");
        link=link.Replace("format=rdf","format=json");
        link=link.Replace("format=rss_200_enc","format=json");
        link=link.Replace("format=php","format=json");
        link=link.Replace("format=php_serial","format=json");
        link=link.Replace("format=csv","format=json");
        link=link.Replace("format=sql","format=json");
        link=link.Replace("format=yaml","format=json");
        link=link.Replace("format=cdf","format=json");
        return (link);

    }

    private SlideShow GetCurrentSlideShow()
    {
        // Get all SlideShows
        List<SlideShow> SlideShows = GetSlideShows();

        // Check for today's SlideShow
        bool update = true;
        SlideShow current = new SlideShow();
        // Ok, we're gonna loop through all the SlideShows/
        foreach (SlideShow SlideShow in SlideShows)
        {
            // do we have one marked for today?
            if (SlideShow.LastDisplayed == DateTime.Now.Date)
            {
                current = SlideShow;
                update = false;
                break;
            }
            else
            {
                // Always grab the oldest SlideShow out there.
                if (current.LastDisplayed > SlideShow.LastDisplayed)
                    current = SlideShow;
            }
        }

        if (update)
        {
            // New SlideShow selected.  Change the Date.
            current.LastDisplayed = DateTime.Now.Date;
            SaveSlideShows(current, SlideShows, SlideShowAction.Update);
        }

        return current;

    }

    private List<SlideShow> GetSlideShows()
    {
        // Check if it is in the cache already
        List<SlideShow> SlideShows;
        try
        {
            SlideShows = (List<SlideShow>)Cache["SlideShow"];
        }
        catch {
            SlideShows = null;
        }

        if (SlideShows == null)
        {
            // Initialize it
            SlideShows = new List<SlideShow>();

            // Read them in
            if (!File.Exists(dataSource))
            {
                // Load initial entry
                int id = 1;
                string source = "http://picasaweb.google.com/data/feed/base/user/maludan/albumid/5007079807980177777?kind=photo&alt=rss&hl=en_US";
                DateTime lastDisplayed = DateTime.MinValue;
                SlideShows.Add(new SlideShow(id, source, lastDisplayed));
            }
            else
            {
                XmlDocument doc = new XmlDocument();
                doc.Load(dataSource);

                foreach (XmlNode node in doc.SelectNodes("SlideShows/SlideShow"))
                {
                    int id = int.Parse(node.SelectSingleNode("id").InnerText);
                    string source = node.SelectSingleNode("Source").InnerText;
                    DateTime lastDisplayed = DateTime.Parse(node.SelectSingleNode("LastDisplayed").InnerText);

                    SlideShow temp = new SlideShow(id, source, lastDisplayed);

                    SlideShows.Add(temp);
                }
            }
            // Add it to the cache.  We don't want to do that too often.
            Cache.Insert("SlideShow", SlideShows, new System.Web.Caching.CacheDependency(dataSource), DateTime.Now.Date.AddDays(1), System.Web.Caching.Cache.NoSlidingExpiration);
        }
        return SlideShows;
    }

    private void SaveSlideShows(SlideShow edit, List<SlideShow> SlideShows, SlideShowAction action)
    {
        int currentID = 0;
        // Update SlideShows
        using (XmlTextWriter writer = new XmlTextWriter(dataSource, System.Text.Encoding.UTF8))
        {
            writer.Formatting = Formatting.Indented;
            writer.Indentation = 4;
            writer.WriteStartDocument(true);
            writer.WriteStartElement("SlideShows");

            foreach (SlideShow SlideShow in SlideShows)
            {
                currentID = SlideShow.ID;

                if (currentID == edit.ID)
                {
                    if (action == SlideShowAction.Update)
                    {
                        if (edit.LastDisplayed == DateTime.MinValue)
                            edit.LastDisplayed = SlideShow.LastDisplayed; // Use SlideShow to get actual date 
                        WriteSlideShow(writer, edit);
                    }
                    // else if (action == SlideShowAction.Delete) do nothing.  We don't want to write it back out
                }
                else
                {
                    WriteSlideShow(writer, SlideShow);
                }
            }

            if (edit.ID == 0 && action == SlideShowAction.Update)
            {
                // We need to add a new one
                currentID++;
                edit.ID = currentID;
                WriteSlideShow(writer, edit);
            }

            writer.WriteEndElement();
        }
    }

    private static void WriteSlideShow(XmlTextWriter writer, SlideShow SlideShow)
    {
        writer.WriteStartElement("SlideShow");

        writer.WriteStartElement("id");
        writer.WriteValue(SlideShow.ID.ToString());
        writer.WriteEndElement();
        writer.WriteStartElement("Source");
        writer.WriteValue(SlideShow.Source);
        writer.WriteEndElement();
        writer.WriteStartElement("LastDisplayed");
        writer.WriteValue(SlideShow.LastDisplayed.ToShortDateString());
        writer.WriteEndElement();

        writer.WriteEndElement();
    }

    protected void BtnAdd_Click(object sender, EventArgs e)
    {
        PnlActions.Enabled = false;
        PnlEditor.Visible = true;
        HfEditID.Value = "0";
    }
    protected void BtnEdit_Click(object sender, EventArgs e)
    {
        PnlActions.Enabled = false;
        PnlEditor.Visible = true;
        TxtSource.Text = lblLink.Text;
        HfEditID.Value = HfSlideShowID.Value;
    }
    protected void BtnDelete_Click(object sender, EventArgs e)
    {
        PnlActions.Enabled = false;

        List<SlideShow> SlideShows = GetSlideShows();
        if (SlideShows.Count > 1)
            PnlDelete.Visible = true;
        else
            PnlError.Visible = true;
    }
    protected void BtnPrev_Click(object sender, EventArgs e)
    {
        int current = int.Parse(HfSlideShowID.Value);
        List<SlideShow> SlideShows = GetSlideShows();

        foreach (SlideShow SlideShow in SlideShows)
        {
            if (SlideShow.ID == current)
                break;
            if (SlideShow.ID < current)
            {
                HfSlideShowID.Value = SlideShow.ID.ToString();
                LblSource.Text = getscript(SlideShow.Source);
                lblLink.Text = SlideShow.Source;
            }
        }
    }
    protected void BtnNext_Click(object sender, EventArgs e)
    {
        int current = int.Parse(HfSlideShowID.Value);
        List<SlideShow> SlideShows = GetSlideShows();

        foreach (SlideShow SlideShow in SlideShows)
        {
            if (SlideShow.ID > current)
            {
                HfSlideShowID.Value = SlideShow.ID.ToString();
                LblSource.Text = getscript(SlideShow.Source);
                lblLink.Text = SlideShow.Source;
                break;
            }
        }
    }
    protected void BtnSave_Click(object sender, EventArgs e)
    {
        int id = int.Parse(HfEditID.Value);
        SlideShow temp = new SlideShow(id, TxtSource.Text, DateTime.MinValue);
        SaveSlideShows(temp, GetSlideShows(), SlideShowAction.Update);
        LblSource.Text = getscript(TxtSource.Text);
        lblLink.Text = TxtSource.Text;
        TxtSource.Text = "";
        PnlActions.Enabled = true;
        PnlEditor.Visible = false;
    }
    protected void BtnCancel_Click(object sender, EventArgs e)
    {
        TxtSource.Text = "";
        PnlActions.Enabled = true;
        PnlEditor.Visible = false;
    }
    protected void BtnYes_Click(object sender, EventArgs e)
    {
        int id = int.Parse(HfSlideShowID.Value);
        SlideShow temp = new SlideShow(id, TxtSource.Text, DateTime.MinValue);
        SaveSlideShows(temp, GetSlideShows(), SlideShowAction.Delete);
        ShowSlideShow();
        PnlActions.Enabled = true;
        PnlDelete.Visible = false;
    }
    protected void BtnNo_Click(object sender, EventArgs e)
    {
        PnlActions.Enabled = true;
        PnlDelete.Visible = false;
    }
    protected void BtnOk_Click(object sender, EventArgs e)
    {
        PnlActions.Enabled = true;
        PnlError.Visible = false;
    }
}

/// <summary>
/// SlideShow Class used for SlideShow of the Day Control
/// </summary>
public class SlideShow
{
    public SlideShow()
    {
        _id = 0;
        _source = "";
        _lastDisplayed = DateTime.Now;
    }
    public SlideShow(int id, string source, DateTime lastDisplayed)
    {
        _id = id;
        _source = source;
        _lastDisplayed = lastDisplayed;
    }

    private int _id;
    public int ID
    {
        get { return _id; }
        set { _id = value; }
    }

    private string _source;
    public string Source
    {
        get { return _source; }
        set { _source = value; }
    }

    private DateTime _lastDisplayed;
    public DateTime LastDisplayed
    {
        get { return _lastDisplayed; }
        set { _lastDisplayed = value; }
    }

}

public enum SlideShowAction
{
    Update,
    Delete
}